Mule Mongo Connector Demo
===========================

INTRODUCTION
------------
This is minimalistic a demo about creating, reading, updating and delete records from a MongoDB database.
It covers basic operation to interact with your MongoDB instance.


HOW TO RUN DEMO
---------------

### Prerequisites
In order to build run this demo project you'll need:

* Anypoint Studio with Mule ESB 3.7 Runtime.
* Mule Mongo Connector v4.0.0.
* MongoDB instance v3.0 or higher.
* MongoDB Credentials.

### Test the flows

With Anypoint Studio up and running, open the Import wizard from the File menu. A pop-up wizard will offer you the chance to pick Anypoint Studio Project from External Location. On the next wizard window point Project Root to the location of the demo project and select the Server Runtime as Mule Server 3.7.0 EE. Once successfully imported the studio will automatically present the Mule Flows.

From the Package Explorer view, expand the demo project and open the mule-app.properties file. Fill in the credentials of MongoDB instance.

Run the demo project and with in the browser hit - **http://localhost:8081**, the result would be a website that consists of four operations (Create, Read, Update and Delete).

html-form-flow : This is our main flow. The result of this flow will be the rendering of our form.html.

**create-mongo-record-flow :** This flow will let you insert a record into your MongoDB database after you press the **Create** button.

**read-mongo-record-flow :** The result of this flow, will be the search of the provided value into MongoDB.  If search fails, you will recieve an error message in order to provide a new value to search.

**update-mongo-record-flow :** In this flow, you will see the **_Id** field of our search. And you can also write a new value in order to update this record.

**delete-mongo-record-flow :** Our final flow, here you will see again the **_Id** field of our search. And if you press Delete, this record will be deleted from your MongoDB database.


SUMMARY
-------

Congratulations! You have imported the Mule Mongo Connector Demo project and used it to do a basic CRUD operation.
